<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-panicking/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_panicking/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_panicking/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_panicking/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">alloc_error_handler</span>)]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">lang_items</span>)]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">never_type</span>)]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">panic_info_message</span>)]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">core_intrinsics</span>)]</span>
<span class="attribute">#![<span class="ident">feature</span>(<span class="ident">thread_local</span>)]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="kw">use</span> <span class="ident">core::cell::Cell</span>;
<span class="kw">use</span> <span class="ident">core::mem::ManuallyDrop</span>;
<span class="kw">use</span> <span class="ident">core::panic::PanicInfo</span>;

<span class="kw">use</span> <span class="ident">icecap_runtime</span>::{<span class="ident">debug_println</span>, <span class="ident">stop_thread</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unwinding&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;postcard&quot;</span>))]</span>
<span class="kw">use</span> <span class="ident">icecap_backtrace</span> <span class="kw">as</span> <span class="ident">backtrace</span>;

<span class="kw">extern</span> <span class="string">&quot;Rust&quot;</span> {
    <span class="kw">fn</span> <span class="ident">__rust_panic_cleanup</span>(<span class="ident">_exception</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>) -&gt; <span class="ident">Payload</span>;
    <span class="kw">fn</span> <span class="ident">__rust_start_panic</span>(<span class="ident">_payload</span>: <span class="ident">Payload</span>) -&gt; <span class="ident">i32</span>;
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span> {
        <span class="kw">mod</span> <span class="ident">with_alloc</span>;
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">with_alloc::Payload</span>;
    } <span class="kw">else</span> {
        <span class="kw">mod</span> <span class="ident">without_alloc</span>;
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">without_alloc::Payload</span>;
    }
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">__rust_drop_panic</span>() -&gt; <span class="op">!</span> {
    <span class="macro">debug_println!</span>(<span class="string">&quot;Rust panics must be rethrown&quot;</span>);
    <span class="ident">core::intrinsics::abort</span>()
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">__rust_foreign_exception</span>() -&gt; <span class="op">!</span> {
    <span class="macro">debug_println!</span>(<span class="string">&quot;Rust cannot catch foreign exceptions&quot;</span>);
    <span class="ident">core::intrinsics::abort</span>()
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">catch_unwind</span><span class="op">&lt;</span><span class="ident">R</span>, <span class="ident">F</span>: <span class="ident">FnOnce</span>() -&gt; <span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">f</span>: <span class="ident">F</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">R</span>, <span class="ident">Payload</span><span class="op">&gt;</span> {
    <span class="kw">union</span> <span class="ident">Data</span><span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">R</span><span class="op">&gt;</span> {
        <span class="ident">f</span>: <span class="ident">ManuallyDrop</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span>,
        <span class="ident">r</span>: <span class="ident">ManuallyDrop</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>,
        <span class="ident">p</span>: <span class="ident">ManuallyDrop</span><span class="op">&lt;</span><span class="ident">Payload</span><span class="op">&gt;</span>,
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">Data</span> {
        <span class="ident">f</span>: <span class="ident">ManuallyDrop::new</span>(<span class="ident">f</span>),
    };

    <span class="kw">let</span> <span class="ident">data_ptr</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">data</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">u8</span>;
    <span class="kw">unsafe</span> {
        <span class="kw">return</span> <span class="kw">if</span> <span class="ident">core::intrinsics</span>::<span class="ident">r#try</span>(<span class="ident">do_call</span>::<span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">R</span><span class="op">&gt;</span>, <span class="ident">data_ptr</span>, <span class="ident">do_catch</span>::<span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">==</span> <span class="number">0</span> {
            <span class="prelude-val">Ok</span>(<span class="ident">ManuallyDrop::into_inner</span>(<span class="ident">data</span>.<span class="ident">r</span>))
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="ident">ManuallyDrop::into_inner</span>(<span class="ident">data</span>.<span class="ident">p</span>))
        };
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">do_call</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnOnce</span>() -&gt; <span class="ident">R</span>, <span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>) {
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">data</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Data</span><span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">R</span><span class="op">&gt;</span>;
            <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> (<span class="kw-2">*</span><span class="ident">data</span>);
            <span class="kw">let</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">ManuallyDrop::take</span>(<span class="kw-2">&amp;mut</span> <span class="ident">data</span>.<span class="ident">f</span>);
            <span class="ident">data</span>.<span class="ident">r</span> <span class="op">=</span> <span class="ident">ManuallyDrop::new</span>(<span class="ident">f</span>());
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">do_catch</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnOnce</span>() -&gt; <span class="ident">R</span>, <span class="ident">R</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>, <span class="ident">exception</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>) {
        <span class="kw">unsafe</span> {
            <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">data</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Data</span><span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">R</span><span class="op">&gt;</span>;
            <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> (<span class="kw-2">*</span><span class="ident">data</span>);
            <span class="kw">let</span> <span class="ident">payload</span> <span class="op">=</span> <span class="ident">__rust_panic_cleanup</span>(<span class="ident">exception</span>);
            <span class="ident">panic_caught</span>();
            <span class="ident">data</span>.<span class="ident">p</span> <span class="op">=</span> <span class="ident">ManuallyDrop::new</span>(<span class="ident">payload</span>);
        }
    }
}

<span class="attribute">#[<span class="ident">thread_local</span>]</span>
<span class="kw">static</span> <span class="ident">PANIC_COUNT</span>: <span class="ident">Cell</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Cell::new</span>(<span class="number">0</span>);

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">panic_caught</span>() {
    <span class="comment">// panic_count::decrease(); // TODO</span>
    <span class="ident">PANIC_COUNT</span>.<span class="ident">set</span>(<span class="number">0</span>);
}

<span class="kw">fn</span> <span class="ident">always_dump_stack_trace</span>() -&gt; <span class="ident">bool</span> {
    <span class="bool-val">true</span>
}

<span class="kw">fn</span> <span class="ident">dump_stack_trace</span>() {
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unwinding&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;postcard&quot;</span>))]</span>
    <span class="ident">backtrace::collect_and_print_pretty_infallible</span>();
}

<span class="kw">fn</span> <span class="ident">do_panic</span>(<span class="ident">payload</span>: <span class="ident">Payload</span>) -&gt; <span class="op">!</span> {
    <span class="kw">if</span> <span class="ident">PANIC_COUNT</span>.<span class="ident">get</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="number">1</span> {
        <span class="ident">dump_stack_trace</span>();
        <span class="macro">debug_println!</span>(<span class="string">&quot;thread panicked while processing panic. aborting.&quot;</span>);
        <span class="ident">stop_thread</span>();
    }
    <span class="ident">PANIC_COUNT</span>.<span class="ident">set</span>(<span class="number">1</span>);
    <span class="kw">if</span> <span class="ident">always_dump_stack_trace</span>() {
        <span class="ident">dump_stack_trace</span>();
    }
    <span class="kw">let</span> <span class="ident">code</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">__rust_start_panic</span>(<span class="ident">payload</span>) };
    <span class="macro">debug_println!</span>(<span class="string">&quot;failed to initiate panic, error {}&quot;</span>, <span class="ident">code</span>);
    <span class="ident">stop_thread</span>();
}

<span class="attribute">#[<span class="ident">panic_handler</span>]</span>
<span class="kw">fn</span> <span class="ident">panic</span>(<span class="ident">info</span>: <span class="kw-2">&amp;</span><span class="ident">PanicInfo</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="op">!</span> {
    <span class="macro">debug_println!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">info</span>);
    <span class="ident">do_panic</span>(<span class="ident">Payload::empty</span>())
}

<span class="comment">// #[track_caller]</span>
<span class="comment">// pub fn panic_any&lt;M: &#39;static + Any + Send&gt;(msg: M) -&gt; ! {</span>
<span class="comment">//     debug_println!(&quot;panicked at {}&quot;, Location::caller());</span>
<span class="comment">//     do_panic(Box::new(msg))</span>
<span class="comment">// }</span>
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_panicking" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>